MovieCatalog/MovieCatalog.MVCView/ViewModels/Shared/PaginatedFilteredViewModel.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using MovieCatalog.Domain.Models;

namespace MovieCatalog.MVCView.ViewModels.Shared;

public abstract class PaginatedFilteredViewModel
{
    private readonly Type _modelType;
    private readonly ICollection<Model> _models = new List<Model>();
    
    public string ControllerName { get; }
    public string ActionName { get; }
    
    public IEnumerable<Model> Models => _models.ToList();
    public int Total { get; set; }

    public string SortColumn { get; set; } = "Id";
    public string SortDirection { get; set; } = "Descending";
    public string Sorting => $"{SortColumn}_{SortDirection}";

    public int CurrentPage { get; set; }
    public int PageSize { get; set; } = 50;
    public int TotalPages => PageSize == 0 ? 0 : (int)Math.Ceiling(Total / (decimal)PageSize);

    public string SearchTerm { get; set; } = string.Empty;

    public abstract IEnumerable<string> Columns { get; }
    public abstract IEnumerable<SelectListItem> SortColumns { get; }
    
    public IEnumerable<SelectListItem> SortDirections { get; } = new[]
    {
        new SelectListItem("Ascending", "Ascending"),
        new SelectListItem("Descending", "Descending", true)
    };

    protected PaginatedFilteredViewModel(Type modelType, Type controllerType)
    {
        if (!typeof(Model).IsAssignableFrom(modelType))
            throw new ArgumentException($"Type '{modelType}' is not a model.");
        
        if (!typeof(Controller).IsAssignableFrom(controllerType))
            throw new ArgumentException($"Type '{controllerType}' is not a controller.");
        
        _modelType = modelType;
        ControllerName = controllerType.Name.Replace("Controller", string.Empty);
        ActionName = "Index";
    }

    public void AddModel(Model model)
    {
        if (model.GetType() != _modelType)
            throw new ArgumentException("Model collection should include only models of the same type.");
        
        _models.Add(model);
    }
    
    public void AddModels(IEnumerable<Model> models)
    {
        foreach (var model in models)
            AddModel(model);
    }
    
    public IDictionary<string, string> ToDictionaryParameters(
        string? searchTerm = null,
        string? sortColumn = null,
        string? sorting = null,
        int? page = null,
        int? pageSize = null)
    {
        return new Dictionary<string, string>
        {
            { "searchTerm", searchTerm ?? SearchTerm },
            { "sorting", sorting ?? Sorting },
            { "sortColumn", sortColumn ?? SortColumn },
            { "pageSize", pageSize?.ToString() ?? PageSize.ToString() },
            { "page", page?.ToString() ?? CurrentPage.ToString() },
        };
    }
    
    public abstract string GetColumnValue(Model model, string column);
    
    public static (string, string) GetSortColumnAndDirection(string sorting, string sortColumn)
    {
        if (string.IsNullOrWhiteSpace(sorting) || string.IsNullOrWhiteSpace(sortColumn))
            return ("Id", "Descending");
        
        if (!sorting.Contains(sortColumn))
            return (sortColumn, "Ascending");
        
        if (sorting.EndsWith("Ascending"))
            return (sortColumn, "Descending");
        
        if (sorting.EndsWith("Descending"))
            return ("Id", "Descending");
        
        // Never happened but...
        return ("Id", "Descending");
    }
}

MovieCatalog/MovieCatalog.MVCView/Controllers/ActorsController.cs
using Microsoft.AspNetCore.Mvc;
using MovieCatalog.Application.Actors;
using MovieCatalog.Domain;
using MovieCatalog.Domain.Models;
using MovieCatalog.MVCView.ViewModels;

namespace MovieCatalog.MVCView.Controllers;

public class ActorsController : Controller
{
    private const int InitialPageSize = 10;
    private const int FirstPageNumber = 1;
    
    private readonly IActorService _actorsService;
    
    public ActorsController(IActorService actorsService)
    {
        _actorsService = actorsService;
    }

    public async Task<IActionResult> Index(CancellationToken cancellationToken)
    {
        var viewModel = await FilterAsync(string.Empty, "Id", "Descending", InitialPageSize, FirstPageNumber, cancellationToken);
        return View(viewModel);
    }

    public IActionResult Create() => View(new Actor { FirstName = string.Empty });
    
    [HttpPost]
    public async Task<IActionResult> Create([Bind("FirstName,LastName,DateOfBirth")] Actor actor, CancellationToken cancellationToken)
    {
        await _actorsService.CreateAsync(actor, cancellationToken);
        return RedirectToAction(nameof(Index));
    }
    
    public async Task<IActionResult> Edit(int id, CancellationToken cancellationToken)
    {
        var actor = await _actorsService.GetAsync(id, cancellationToken);
        return View(actor);
    }
    
    [HttpPost]
    public async Task<IActionResult> Edit([Bind("Id,FirstName,LastName,DateOfBirth")] Actor actor, CancellationToken cancellationToken)
    {
        await _actorsService.UpdateAsync(actor, cancellationToken);
        return RedirectToAction(nameof(Index));
    }
    
    public async Task<IActionResult> Delete(int id, CancellationToken cancellationToken)
    {
        await _actorsService.DeleteAsync(id, cancellationToken);
        return RedirectToAction(nameof(Index));
    }

    public async Task<IActionResult> Filter(
        string searchTerm, string sortColumn, string sortDirection, int pageSize, int currentPage, CancellationToken cancellationToken)
    {
        var viewModel = await FilterAsync(searchTerm, sortColumn, sortDirection, pageSize, currentPage, cancellationToken);
        return View(nameof(Index), viewModel);
    }

    private async Task<ActorsViewModel> FilterAsync(
        string searchTerm, string sortColumn, string sortDirection, int pageSize, int pageNumber, CancellationToken cancellationToken)
    {
        var dto = new FilterPaginationDto(searchTerm, pageNumber, pageSize, sortColumn, 
            sortDirection.Equals("Descending", StringComparison.OrdinalIgnoreCase) ? SortOrder.Desc : SortOrder.Asc);
        
        var actors = await _actorsService.GetAllAsync(dto, cancellationToken);
        return new ActorsViewModel
        {
            Actors = actors.Models,
            TotalActors = actors.Total,
            PageSize = dto.PageSize,
            CurrentPage = dto.PageNumber,
            SearchTerm = string.Empty,
            SortColumn = dto.SortColumn,
            SortDirection = dto.SortOrder == SortOrder.Asc ? "Ascending" : "Descending"
        };
    }
}

MovieCatalog/MovieCatalog.MVCView/Controllers/CategoriesController.cs
using MovieCatalog.Application.Categories;
using MovieCatalog.Domain.Models;

namespace MovieCatalog.MVCView.Controllers;

public sealed class CategoriesController : FilteredPaginatedController<Category>
{
    private readonly ICategoryService _categoryService;

    public CategoriesController(ICategoryService categoryService) : base(categoryService)
    {
        _categoryService = categoryService;
    }
}

MovieCatalog/MovieCatalog.MVCView/Views/Shared/PaginatedFilteredTable.cshtml
@model MovieCatalog.MVCView.ViewModels.Shared.PaginatedFilteredViewModel

<div>
    <form method="get" asp-controller="@Model.ControllerName" asp-action="@Model.ActionName" asp-all-route-data="@Model.ToDictionaryParameters()">
        <input asp-for="SortColumn" hidden>
        <input asp-for="SortDirection" hidden>
        <input asp-for="Sorting" hidden>
        <input asp-for="PageSize" hidden>
        <input asp-for="CurrentPage" hidden>
        <div class="search-form">
            <input class="form-control" asp-for="SearchTerm" placeholder="Search...">
            <button type="submit" class="btn btn-primary">Search</button>
        </div>
    </form>
    <table class="table">
        <thead>
        @foreach (var column in Model.Columns)
        {
            <th>
                <a class="column-header"
                   asp-controller="@Model.ControllerName"
                   asp-action="@Model.ActionName"
                   asp-all-route-data="@Model.ToDictionaryParameters(sortColumn: column, page: 1)">
                    @column
                </a>

                @{
                    var sorting = Model.Sorting;
                    var isSortingColumn = sorting.Contains(column);

                    if (isSortingColumn && sorting.EndsWith("ascending", StringComparison.OrdinalIgnoreCase))
                    {
                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sort-down" viewBox="0 0 16 16">
                            <path d="M3.5 2.5a.5.5 0 0 0-1 0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 11.293V2.5zm3.5 1a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zM7.5 6a.5.5 0 0 0 0 1h5a.5.5 0 0 0 0-1h-5zm0 3a.5.5 0 0 0 0 1h3a.5.5 0 0 0 0-1h-3zm0 3a.5.5 0 0 0 0 1h1a.5.5 0 0 0 0-1h-1z"/>
                        </svg>
                    }
                    else if (isSortingColumn && sorting.EndsWith("descending", StringComparison.OrdinalIgnoreCase))
                    {
                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sort-up" viewBox="0 0 16 16">
                            <path d="M3.5 12.5a.5.5 0 0 1-1 0V3.707L1.354 4.854a.5.5 0 1 1-.708-.708l2-1.999.007-.007a.498.498 0 0 1 .7.006l2 2a.5.5 0 1 1-.707.708L3.5 3.707V12.5zm3.5-9a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zM7.5 6a.5.5 0 0 0 0 1h5a.5.5 0 0 0 0-1h-5zm0 3a.5.5 0 0 0 0 1h3a.5.5 0 0 0 0-1h-3zm0 3a.5.5 0 0 0 0 1h1a.5.5 0 0 0 0-1h-1z"/>
                        </svg>
                    }
                }
            </th>
        }
        </thead>
        <tbody>
        @foreach (var model in Model.Models)
        {
            <tr>
                @foreach (var column in Model.Columns)
                {
                    <td>@Model.GetColumnValue(model, column)</td>
                }
            </tr>
        }
        </tbody>
    </table>
    <div class="pagination">
        <a class="btn btn-primary pagination-button" asp-controller="@Model.ControllerName" asp-action="@Model.ActionName" asp-all-route-data="@Model.ToDictionaryParameters(page: 1)">First</a>
        @if (Model.CurrentPage == 1)
        {
            <div class="btn btn-secondary pagination-button">First</div>
        }
        else
        {
            <a class="btn btn-primary pagination-button" asp-controller="@Model.ControllerName" asp-action="@Model.ActionName" asp-all-route-data="@Model.ToDictionaryParameters(page: Model.CurrentPage - 1)">Previous</a>
        }
        <form method="get" asp-controller="@Model.ControllerName" asp-action="@Model.ActionName" asp-all-route-data="@Model.ToDictionaryParameters()">
            <input asp-for="SearchTerm" hidden>
            <input asp-for="SortColumn" hidden>
            <input asp-for="SortDirection" hidden>
            <input asp-for="Sorting" hidden>
            <input asp-for="PageSize" hidden>
            <input type="number" min="1" max="@Model.TotalPages" value="@Model.CurrentPage" name="page">
            <button type="submit" class="btn btn-primary pagination-button">Go</button>
        </form>
        @if (Model.CurrentPage == Model.TotalPages)
        {
            <div class="btn btn-secondary pagination-button">Next</div>
        }
        else
        {
            <a class="btn btn-primary pagination-button" asp-controller="@Model.ControllerName" asp-action="@Model.ActionName" asp-all-route-data="@Model.ToDictionaryParameters(page: Model.CurrentPage + 1)">Next</a>
        }
        <a class="btn btn-primary pagination-button" asp-controller="@Model.ControllerName" asp-action="@Model.ActionName" asp-all-route-data="@Model.ToDictionaryParameters(page: Model.TotalPages)">Last</a>
    </div>
</div>

<style>
    .search-form {
        display: flex;
        justify-content: center;
        align-items: center;
    }
    
    a.column-header {
        text-decoration: none;
        color: var(--bs-light-bg-subtle);
    }
    
    .pagination {
        display: flex;
        justify-content: center;
        align-items: center;
    }
    
    .pagination .pagination-button {
        margin: 0 0.2rem;
    }
</style>

MovieCatalog/MovieCatalog.MVCView/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - MovieCatalog.MVCView</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/MovieCatalog.MVCView.styles.css" asp-append-version="true" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">MovieCatalog.MVCView</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Actors" asp-action="Index">Actors</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Categories" asp-action="Index">Categories</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2023 - MovieCatalog.MVCView - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>